/*
 * %Z%%M%    %I%  %W%  %G%  %U%
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 * Licensed Materials - Property of IBM
 * IBM Security Software Development Kit, Java (tm) Technology Edition
 *
 * (C) Copyright IBM Corp. 1999, 2000 All Rights Reserved.
 *
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright Office.
 * ===========================================================================
 */
 
//
//     SAMPLE IBMJCE CODE
//

/*
 * Usage: This sample code demonstrate how to use the message digest
 *        for MD2 and MD5 algorithms.
 *
 
 * Requirement: Usage of this sample file requires the installation of
 *        the IBMJCE provider on the running machine and the CLASSPATH
 *        points to the classes.
 *
 *
 * Running the program by typing the following in a command line:
 *
 *       java SampleMessageDigest
 *
 */


import java.io.*;
import java.security.MessageDigest;
import java.math.BigInteger;


public class SampleMessageDigests {
    
    // message to be signed
    static final byte[] originalMessage = "testmessage_a very long test message".getBytes();


    /***************
     * MAIN PROGRAM
     ***************/
    public static void main(String argv[]) {
        
        MessageDigest md = null;
        byte[] messagedigest = null;
    
    /*********************
     * Get a MD2 instance
     ********************/
     
        // Now, get an instance of the MD2 message digest
        try {
            System.out.println("Get a MD2 message digest instance");
            md = MessageDigest.getInstance("MD2", "IBMJCE");
        
        } catch (Exception ex) {
            System.out.println("Error getting MD2 instance: " + ex.getMessage());
        }
        System.out.println();
        
        
    /********************************** 
     * Generating a MD2 message digest
     *********************************/
     
        try { 
        
            /*
              1. Reset                      [MessageDigest.reset()]
              2. Update with the message    [MessageDigest.update(byte[])]
              3. Get the message digest     [MessageDigest.digest()/MessageDigest.digest(byte[])]              
            */
             
            System.out.println("Generating first MD2 message digest");
            md.reset();
            md.update(originalMessage);
            messagedigest = md.digest();
                    
            System.out.println(new BigInteger(messagedigest));                    
        } catch (Exception ex) {
            System.out.println("Error generating a message digest: " + ex.getMessage());
        }
        System.out.println();

       messagedigest = null;
       try { 
        
            System.out.println("Generating second MD2 message digest");
            md.reset();
            md.update(originalMessage);
            messagedigest = md.digest();
                    
            System.out.println(new BigInteger(messagedigest));                    
        } catch (Exception ex) {
            System.out.println("Error generating a message digest: " + ex.getMessage());
        }
        System.out.println();
        
        
     
     /********************
     * Get a MD5 instance
     *********************/
     
        // Now, get an instance of the MD5 message digest
        try {
            System.out.println("Get a MD5 message digest instance");
            md = MessageDigest.getInstance("MD5", "IBMJCE");
        
        } catch (Exception ex) {
            System.out.println("Error getting MD5 instance: " + ex.getMessage());
        }
        System.out.println(); 
      
      /******************************** 
     * Generating a MD5 message digest
     **********************************/
     
        try { 
        
            /*
              1. Reset                      [MessageDigest.reset()]
              2. Update with the message    [MessageDigest.update(byte[])]
              3. Get the message digest     [MessageDigest.digest()/MessageDigest.digest(byte[])]              
            */
             
            System.out.println("Generating first MD5 message digest");
            md.reset();
            md.update(originalMessage);
            messagedigest = md.digest();
                    
            System.out.println(new BigInteger(messagedigest));                    
        } catch (Exception ex) {
            System.out.println("Error generating a message digest: " + ex.getMessage());
        }
        System.out.println();

       messagedigest = null;
       try { 
        
            System.out.println("Generating second MD5 message digest");
            md.reset();
            md.update(originalMessage);
            messagedigest = md.digest();
                    
            System.out.println(new BigInteger(messagedigest));                    
        } catch (Exception ex) {
            System.out.println("Error generating a message digest: " + ex.getMessage());
        }
        System.out.println();  
        
        
    /*********************
     * Get a SHA1 instance
     ********************/
     
        // Now, get an instance of the SHA1 message digest
        try {
            System.out.println("Get a SHA1 message digest instance");
            md = MessageDigest.getInstance("SHA1", "IBMJCE");
        
        } catch (Exception ex) {
            System.out.println("Error getting SHA1 instance: " + ex.getMessage());
        }
        System.out.println();
                
    /********************************** 
     * Generating a SHA1 message digest
     *********************************/
     
        try { 
        
            /*
              1. Reset                      [MessageDigest.reset()]
              2. Update with the message    [MessageDigest.update(byte[])]
              3. Get the message digest     [MessageDigest.digest()/MessageDigest.digest(byte[])]              
            */
             
            System.out.println("Generating first SHA1 message digest");
            md.reset();
            md.update(originalMessage);
            messagedigest = md.digest();
                    
            System.out.println(new BigInteger(messagedigest));                    
        } catch (Exception ex) {
            System.out.println("Error generating a message digest: " + ex.getMessage());
        }
        System.out.println();

       messagedigest = null;
       try { 
        
            System.out.println("Generating second SHA1 message digest");
            md.reset();
            md.update(originalMessage);
            messagedigest = md.digest();
                    
            System.out.println(new BigInteger(messagedigest));                    
        } catch (Exception ex) {
            System.out.println("Error generating a message digest: " + ex.getMessage());
        }
        System.out.println();
        
	}
}


