/* 
 * %Z%%M%    %I%  %W%  %G%  %U%
 * ===========================================================================
 * Licensed Materials - Property of IBM
 * IBM Security Software Development Kit, Java (tm) Technology Edition
 * 
 * (C) Copyright IBM Corp. 2000 All Rights Reserved.
 * 
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 * ===========================================================================
 */

import com.ibm.security.pkcs9.UnstructuredName;

/*
 * PKCS9MultiValAttr
 *
 * Sample program to demonstrate the creation and use of a PKCS #9 
 * multi-valued attribute such as UnstructuredName, which is implemented by the 
 * com.ibm.security.pkcs9.UnstructuredName class.
 *
 * You can build this sample program class by issuing the following command:
 *
 *     javac PKCS9MultiValAttr.java
 *
 * Make sure that the ibmpkcs.jar file is in your CLASSPATH or extensions directory.
 *
 * To run this sample program, execute the following command:
 *
 *     java PKCS9MultiValAttr
 */

public class PKCS9MultiValAttr {

    public static void main(String[] args) {

        /* 
         * UnstructuredName is a representative multi-valued attribute.
         * Similar operations can be performed on other PKCS #9 single-valued
         * attributes, such as Counersignature, EmailAddress, and 
         * UnstructuredAddress.
         */

        /*
         * Create some names. 
         */
        String[] names = { "name1", "name2", "name3" };

        /*
         * Create an UnstructuredName attribute.
         */
        UnstructuredName unstructuredNames = new UnstructuredName(names);
        System.out.println("SUCCESS: Created UnstructuredName attribute with the following names"); 

        String[] attrNames = unstructuredNames.getUnstructuredNames();
        for (int i = 0; i < attrNames.length; i++) {
             System.out.println("\t" + attrNames[i]);
        } 
    }
}
