/* 
 * %Z%%M%    %I%  %W%  %G%  %U%
 * ===========================================================================
 * Licensed Materials - Property of IBM
 * IBM Security Software Development Kit, Java (tm) Technology Edition
 * 
 * (C) Copyright IBM Corp. 2000 All Rights Reserved.
 * 
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 * ===========================================================================
 */

import java.util.Calendar;
import java.util.Date;
import com.ibm.security.pkcs9.SigningTime;

/*
 * PKCS9SingleValAttr
 *
 * Sample program to demonstrate the creation and use of a PKCS #9 
 * single-valued attribute such as SigningTime, which is implemented by the 
 * com.ibm.security.pkcs9.SigningTime class.
 *
 * You can build this sample program class by issuing the following command:
 *
 *     javac PKCS9SingleValAttr.java
 *
 * Make sure that the ibmpkcs.jar file is in your CLASSPATH or extensions directory.
 *
 * To run this sample program, execute the following command:
 *
 *     java PKCS9SingleValAttr
 */

public class PKCS9SingleValAttr {

    public static void main(String[] args) {

        /* 
         * SigningTime is a representative single-valued attribute.
         * Similar operations can be performed on other PKCS #9 single-valued
         * attributes, such as ChallengePassword, ContentType,
         * ExtendedCertificateAttributes, FriendlyName, LocalKeyId,
         * and MessageDigest.
         */

        /*
         * Get the current date.
         */
        Calendar cal = Calendar.getInstance();
        Date date = cal.getTime();

        /*
         * Create a SigningTime attribute.
         */
        SigningTime signingTime = new SigningTime(date);
        System.out.println("SUCCESS: Created SigningTime attribute with the current date");
        System.out.println(signingTime.toString());
    }
}
